// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_D3DResource1.h"

/// A texture resource class contains the information about a texture that
/// has been loaded into a graphics API specific implementation.
class UWBD3D_EffectResource : public UWBD3D_Resource {
public:
  UWBD3D_EffectResource();
  ~UWBD3D_EffectResource();

  ///
  /// Get the Direct3D texture for this image
  ID3DXEffect* GetD3DEffct() { return m_pEffect; }
protected:
  virtual void ReleaseMemory(); 
  virtual bool LoadResourceFromFile(const wchar_t* fullPathName);
  
  ID3DXEffect *m_pEffect;
};
