// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////
#pragma once

#include "uwbgl_D3DSpotLight1.h"
#include "uwbgl_D3DPrimitiveMesh3.h"
#include "uwbgl_SceneNode7.h"
#include "uwbgl_PrimitiveLine6.h"

UWBD3D_SpotLight::UWBD3D_SpotLight(int id) : UWBD3D_Light(id)
{
  SetToSpotLight();
}

UWBD3D_SpotLight::~UWBD3D_SpotLight()
{
}

void UWBD3D_SpotLight::DrawLightGeometry(UWB_DrawHelper& draw_helper)
{ 
  UWB_Color c = GetDiffuse();
  UWBD3D_PrimitiveMesh *m = new UWBD3D_PrimitiveMesh(L"sphere.x");
  m->EnableLighting(false);
  m->SetShadeMode(smFlat);
  m->SetFlatColor(c);

  UWB_SceneNode node;
  UWB_XformInfo xf = node.GetXformInfo();
  vec3 p;
  GetPosition(p);
  xf.SetTranslation( p);
  node.SetXformInfo( xf );
    
  node.SetPrimitive( m );
  node.Draw(draw_helper.GetLOD(), draw_helper);

}